buku/urls.py
from django.urls import path


from . import views
from buku.views import dataBuku

app_name = 'buku'

urlpatterns = [
    path('', views.home, name='home'),
    path('dataBuku/', dataBuku)
]

kegiatan/urls.py
from django.urls import path

from . import views

app_name = 'kegiatan'

urlpatterns = [
    path('', views.kegiatan, name='kegiatan'),
    path('tambah-kegiatan/submitFormKegiatan', views.submitFormKegiatan),
    path('tambah-peserta/submitFormPeserta', views.submitFormPeserta),
    path('tambah-kegiatan/', views.tambahKegiatan, name='tambahKegiatan'),
    path('tambah-peserta/<int:pk>', views.tambahPeserta, name='tambahPeserta'),
    path('hapusKegiatan/<int:pk>', views.hapusKegiatan, name='hapusKegiatan'),
    path('hapusKegiatanBeneran/<int:pk>', views.hapusKegiatanBeneran, name='hapusKegiatanBeneran'),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
]

storyppw/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('story1/', include('story1.urls')),
    path('story3/', include('story3.urls')),
    path('form-matkul/', include('form.urls')),
    path('kegiatan/', include('kegiatan.urls')),
    path('buku/', include('buku.urls')),
    path('userAuth/', include('userAuth.urls')),
]

kegiatan/models.py
from django.db import models

class Kegiatan(models.Model):
    nama = models.CharField(max_length = 50)
    deskripsi = models.TextField()
    
class Peserta(models.Model):
    nama = models.CharField(max_length = 50)
    kegiatan = models.ForeignKey(Kegiatan, on_delete = models.CASCADE)

kegiatan/forms.py
from django import forms
from .models import Kegiatan, Peserta

class FormKegiatan(forms.ModelForm):
    class Meta:
        model = Kegiatan
        fields = ["nama", "deskripsi"]
    
    error_messages = {
        'required' : 'Informasi Wajib Diisi'
    }
    
    input_attrs_nama = {
        'type' : 'text',
        'placeholder' : 'Nama Kegiatan',
        'class' : 'form-control',
        'autocomplete' : 'off'
    }
    
    input_attrs_deskripsi = {
        'type' : 'text',
        'placeholder' : 'Deskripsi Kegiatan',
        'class' : 'form-control',
        'autocomplete' : 'off'
    }
    
    nama = forms.CharField(label='', required=True, max_length=50, widget=forms.TextInput(attrs=input_attrs_nama))
    deskripsi = forms.CharField(label='', required=True, widget=forms.Textarea(attrs=input_attrs_deskripsi))


class FormPeserta(forms.ModelForm):
    class Meta:
        model = Peserta
        fields = ["nama"]
        exclude = ('kegiatan',)
    
    error_messages = {
        'required' : 'Informasi Wajib Diisi'
    }
    
    input_attrs_nama = {
        'type' : 'text',
        'placeholder' : 'Nama Peserta',
        'class' : 'form-control',
        'autocomplete' : 'off'
    }
    
    nama = forms.CharField(label='', required=True, max_length=50, widget=forms.TextInput(attrs=input_attrs_nama))

kegiatan/views.py
from django.shortcuts import render, redirect
from .forms import FormKegiatan, FormPeserta
from .models import Kegiatan, Peserta

def kegiatan(request):
    semuaKegiatan = Kegiatan.objects.all()
    semuaPeserta = Peserta.objects.all()
    context = {
        'kegiatans' : semuaKegiatan,
        'pesertas' : semuaPeserta
    }
    return render(request, 'kegiatan/kegiatan.html', context)

def tambahKegiatan(request):
    response = {'form' : FormKegiatan}
    return render(request, 'kegiatan/tambahKegiatan.html', response)
    
def submitFormKegiatan(request):
    form = FormKegiatan(request.POST or None)
    if (form.is_valid() and request.method == "POST"):
        form.save()
    return redirect('kegiatan:tambahKegiatan')
    
def tambahPeserta(request, pk):
    objekKegiatan = Kegiatan.objects.get(pk=pk)
    response = {
        'form' : FormPeserta,
        'kegiatan' : objekKegiatan
    }
    return render(request, 'kegiatan/tambahPeserta.html', response)    
    
def submitFormPeserta(request):
    pk = request.POST.get('kegiatan_pk')
    objekKegiatan = Kegiatan.objects.get(pk=pk)

    form = FormPeserta(request.POST or None)
    if (form.is_valid() and request.method == "POST"):
        savedForm = form.save(commit=False)
        savedForm.kegiatan = objekKegiatan
        savedForm.save()
    return redirect('kegiatan:kegiatan')

def hapusKegiatan(request, pk):
    objekKegiatan = Kegiatan.objects.get(pk=pk)
    semuaPeserta = Peserta.objects.all()
    response = {
        'kegiatan' : objekKegiatan,
        'pesertas' : semuaPeserta
    }
    return render(request, 'kegiatan/hapusKegiatan.html', response)
    
def hapusKegiatanBeneran(request, pk):
    Kegiatan.objects.get(pk=pk).delete()
    return redirect('kegiatan:kegiatan')

kegiatan/templates/kegiatan/hapusKegiatan.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Rico Tadjudin | Hapus Kegiatan</title>
<link rel="stylesheet" href="{% static "kegiatan/css/formStyles.css" %}">
{% endblock meta %}

{% block content %}
    <div class="container">
        <div id="content" class="background content" style="background-image: url({% static 'main/img/space2.jpg' %}); background-size: 100% auto;">

            <div class="background-content">
                <div id="judul">
                    <p>Hapus<br>{{ kegiatan.nama }}?</p>
                </div>
            </div>
            
            <div>
            {% if kegiatan %}
                    <div class="background-content">
                        <div class="atasbawah">
                            <div class="kanankiriKegiatan">
                                <div class="atasbawah kotakKegiatan1">
                                    <p class="subjudul">{{ kegiatan.nama }}</p>
                                    <p id="deskripsi">{{ kegiatan.deskripsi }}</p>
                                </div>
                                <div class="atasbawah kotakKegiatan2">
                                    <table>
                                        <thead>
                                            <tr>
                                                <th id="th1">Peserta</th>
                                            </tr>
                                        </thead>
                                        {% if pesertas %}
                                            {% for peserta in pesertas %}
                                                {% if peserta.kegiatan == kegiatan %}
                                                    <tbody>
                                                        <td id="td1">{{ peserta.nama }}</td>
                                                    </tbody>
                                                {% endif %} 
                                            {% endfor %} 
                                        {% endif %}
                                    </table>
                                </div>
                            </div>
                            <div class="kanankiri" style="padding:0">
                                <a href="{% url 'kegiatan:kegiatan' %}" class="button1" id="button-tambahPeserta">kembali</a>
                                <a href="{% url 'kegiatan:hapusKegiatanBeneran' kegiatan.pk %}" class="button1" id="button-tambahPeserta">Hapus</a>
                            </div>
                        </div>
                    </div>
            {% endif %}
            </div>
            
            <div>
                <a href="{% url 'main:home' %}" class="button1">Home</a>
            </div>
        </div>
    </div>
{% endblock content %}

kegiatan/templates/kegiatan/kegiatan.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Rico Tadjudin | Kegiatan</title>
<link rel="stylesheet" href="{% static "kegiatan/css/formStyles.css" %}">
{% endblock meta %}

{% block content %}
    <div class="container">
        <div id="content" class="background content" style="background-image: url({% static 'main/img/space2.jpg' %}); background-size: 100% auto;">

            <div class="background-content">
                <div id="judul">
                    <p>Kegiatan-Kegiatan</p>
                </div>
            </div>
            
            <div>
            {% if kegiatans %}
                {% for kegiatan in kegiatans %}
                    <div class="background-content">
                        <div class="atasbawah">
                            <div class="kanankiriKegiatan">
                                <div class="atasbawah kotakKegiatan1">
                                    <p class="subjudul">{{ kegiatan.nama }}</p>
                                    <p id="deskripsi">{{ kegiatan.deskripsi }}</p>
                                </div>
                                <div class="atasbawah kotakKegiatan2">
                                    <table>
                                        <thead>
                                            <tr>
                                                <th id="th1">Peserta</th>
                                            </tr>
                                        </thead>
                                        {% if pesertas %}
                                            {% for peserta in pesertas %}
                                                {% if peserta.kegiatan == kegiatan %}
                                                    <tbody>
                                                        <td id="td1">{{ peserta.nama }}</td>
                                                    </tbody>
                                                {% endif %}
                                            {% endfor %} 
                                        {% endif %}
                                    </table>
                                </div>
                            </div>
                            <div class="kanankiri">
                                <a href="{% url 'kegiatan:tambahPeserta' kegiatan.pk %}" class="button1" id="button-tambahPeserta">Tambah Peserta</a>
                                <a href="{% url 'kegiatan:hapusKegiatan' kegiatan.pk %}" class="button1" id="button-tambahPeserta">Hapus</a>
                            </div>
                        </div>
                    </div>
                {% endfor %}
            {% endif %}
            </div>
            
            <div>
                <a href="{% url 'main:home' %}" class="button1">Home</a>
            </div>
        </div>
    </div>
{% endblock content %}

kegiatan/templates/kegiatan/tambahKegiatan.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Rico Tadjudin | Tambah Kegiatan</title>
<link rel="stylesheet" href="{% static "kegiatan/css/formStyles.css" %}">
{% endblock meta %}

{% block content %}
    <div class="container">
        <div id="content" class="content" style="background-image: url({% static 'main/img/space2.jpg' %}); background-size: 100% auto;">
            
            <div class="background-content">
                <div id="judul">
                    <p>Tambah Kegiatan</p>
                </div>
            
                <div class="form">
                    <form action="submitFormKegiatan" method="POST">
                        {% csrf_token %}
                        {{ form.as_p }}
                        <div class="kanankiri">
                            <a href="{% url 'main:home' %}" class="button1">Cancel</a>
                            <input type = "submit" value="Submit" class="button1">
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}

kegiatan/templates/kegiatan/tambahPeserta.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Rico Tadjudin | Tambah Peserta</title>
<link rel="stylesheet" href="{% static "kegiatan/css/formStyles.css" %}">
{% endblock meta %}

{% block content %}
    <div class="container">
        <div id="content" class="content" style="background-image: url({% static 'main/img/space2.jpg' %}); background-size: 100% auto;">
            
            <div class="background-content">
                <div id="judul">
                    <p>Tambah Peserta<br>{{ kegiatan.nama }}</p>
                </div>
            
                <div class="form">
                    <form action="submitFormPeserta" method="POST">
                        <input type="hidden" name="kegiatan_pk" value="{{ kegiatan.pk }}" />
                        {% csrf_token %}
                        {{ form.as_p }}
                        <div class="kanankiri">
                            <a href="{% url 'main:home' %}" class="button1">Cancel</a>
                            <input type = "submit" value="Submit" class="button1">
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}